module Vr7seg(A, B, C, D, EN,
              SEGA, SEGB, SEGC, SEGD, SEGE, SEGF, SEGG);
  input A, B, C, D, EN;
  output SEGA, SEGB, SEGC, SEGD, SEGE, SEGF, SEGG;
  reg SEGA, SEGB, SEGC, SEGD, SEGE, SEGF, SEGG;
  reg [1:7] SEGS;

  always @ (A or B or C or D or EN) begin
    if (EN) 
      case ({D,C,B,A})
// Segment patterns   abcdefg
        0:  SEGS = 7'b1111110;  // 0 
        1:  SEGS = 7'b0110000;  // 1 
        2:  SEGS = 7'b1101101;  // 2 
        3:  SEGS = 7'b1111001;  // 3 
        4:  SEGS = 7'b0110011;  // 4 
        5:  SEGS = 7'b1011011;  // 5 
        6:  SEGS = 7'b0011111;  // 6 (no 'tail')
//      6:  SEGS = 7'b1011111;  // 6 ('tail' included)
        7:  SEGS = 7'b1110000;  // 7 
        8:  SEGS = 7'b1111111;  // 8 
        9:  SEGS = 7'b1110011;  // 9 (no 'tail')
//      9:  SEGS = 7'b1111011;  // 9 ('tail' included)
//      10: SEGS = 7'b1110111;  // A 
//      11: SEGS = 7'b0011111;  // b 
//      12: SEGS = 7'b1001110;  // C 
//      13: SEGS = 7'b0111101;  // d 
//      14: SEGS = 7'b1001111;  // E 
//      15: SEGS = 7'b1000111;  // F
        default: SEGS = 7'bx;
      endcase
    else SEGS = 7'b0;
    {SEGA, SEGB, SEGC, SEGD, SEGE, SEGF, SEGG} = SEGS;
  end
endmodule
